// Tile movement by Radnen //

var g_move_allow    = 0;                
var g_able_move     = -1;              
var g_tile_movement = true;
var g_last_x = 0;
var g_last_y = 0;

function Movement(amount)
{
	var aplha_x = 0;
	var alpha_y = 0;
	var player = GetInputPerson();
	
	//---= Set Commands =---//
	if (IsKeyPressed(KEY_UP))
	{
		alpha_y = g_tile_movement ? (amount / GetPersonSpeedY(player)) : GetPersonSpeedY(player);
		alpha_y *= -1;
		command = COMMAND_MOVE_NORTH;
		face = COMMAND_FACE_NORTH;
		QueuePersonCommand(player,face,true);
		g_move_allow=1;
	}
	else if (IsKeyPressed(KEY_DOWN))
	{
		alpha_y = g_tile_movement ? (amount / GetPersonSpeedY(player)) : GetPersonSpeedY(player);
		command = COMMAND_MOVE_SOUTH;
		face = COMMAND_FACE_SOUTH;
		QueuePersonCommand(player,face,true);
		g_move_allow=1;
	}
	else if (IsKeyPressed(KEY_RIGHT))
	{
		aplha_x = g_tile_movement ? (amount / GetPersonSpeedX(player)) : GetPersonSpeedX(player);
		command = COMMAND_MOVE_EAST;
		face = COMMAND_FACE_EAST;
		QueuePersonCommand(player,face,true);
		g_move_allow=1;
	}
	else if (IsKeyPressed(KEY_LEFT))
	{
		aplha_x = g_tile_movement ? (amount / GetPersonSpeedX(player)) : GetPersonSpeedX(player);
		aplha_x *= -1;
		command = COMMAND_MOVE_WEST;
		face = COMMAND_FACE_WEST;
		QueuePersonCommand(player,face,true);
		g_move_allow=1;
	}
	else if (IsKeyPressed(KEY_SHIFT))
	{
		mainMenu();
	}
	else if (IsKeyPressed(KEY_ESCAPE))
	{
		QuitTheGame();
	}
	
	//---= Stop Person =---//
	if(!IsPersonObstructed(player,GetPersonX(player) + aplha_x,GetPersonY(player) + alpha_y))
	{
		g_able_move = Math.max(Math.abs(aplha_x), Math.abs(alpha_y));
	}
	
	//---= Do Commands =---//
	g_last_x = GetPersonX(player);
	g_last_y = GetPersonY(player);
	if (g_move_allow == 1)
	{
		if (g_able_move > 0)
		{
			for (var j = 0; j < amount; ++j)
			{
				QueuePersonCommand(player,command,false);
				FrameDelay(4);
			}
			g_move_allow=0;
			if (!IsAnyKeyPressed())
			{
				SetPersonFrame(player,0);
			}
		}
		else
		{
			for (var j = 0; j < amount; ++j)
			{
				QueuePersonCommand(player,COMMAND_ANIMATE,false);
				FrameDelay(4);
			}
			g_move_allow=0;
		}
		
		if(GetTileName(GetTile(GetPersonX(GetInputPerson())/16,GetPersonY(GetInputPerson())/16,GetPersonLayer(GetInputPerson()))) == "grassLong"){
			if(Math.floor(Math.random()*10 > 9)){ battle(EnemyGroup[0],bg1); }
		}
	}
	//---= For Collision With Moving Entities ---=//
	if (Math.pow((GetPersonX(player) - g_last_x),2) != 256 && (GetPersonX(player) - g_last_x) != 0)
	{
		SetPersonX(player,g_last_x);
	}
	if (Math.pow((GetPersonY(player) - g_last_y),2) != 256 && (GetPersonY(player) - g_last_y) != 0)
	{
		SetPersonY(player,g_last_y);
	}
	
}

// needed to delay the frame and animate the map //

function FrameDelay(timems)//useful for animations to be drawn
{                          // at the same map fps.
	var time = GetTime();
	SetFrameRate(GetMapEngineFrameRate());// set fps to that of the map engine
	while (GetTime() < time+timems)       // update and draw.
	{
		UpdateMapEngine();
		RenderMap();
		FlipScreen();
	}
	SetFrameRate(0);                      // set back to normal fps.
}

// Now, this is for Entity Movement:

function GetFace(direction)
{
	if (direction == COMMAND_MOVE_NORTH) return COMMAND_FACE_NORTH;
	if (direction == COMMAND_MOVE_SOUTH) return COMMAND_FACE_SOUTH;
	if (direction == COMMAND_MOVE_EAST) return COMMAND_FACE_EAST;
	if (direction == COMMAND_MOVE_WEST) return COMMAND_FACE_WEST;
}

var g_temp_x = 0;
var g_temp_y = 0;

function Walk(who,command,face)
{
	var tile_size = GetTileWidth();
	if (face == undefined) face = GetFace(command);
	QueuePersonCommand(who,face,true);
	g_temp_x = GetPersonX(who);
	g_temp_y = GetPersonY(who);
	for (var y = 0; y < tile_size; ++y)
	{
		QueuePersonCommand(who,command,false);
	}
	if (Math.pow((GetPersonX(who) - g_temp_x),2) != 256 && (GetPersonX(who) - g_temp_x) != 0)
	{
		SetPersonX(who,0);
		Abort(Math.pow((GetPersonX(who) - g_temp_x),2));
	}
	if (Math.pow((GetPersonY(who) - g_temp_y),2) != 256 && (GetPersonY(who) - g_temp_y) != 0)
	{
		SetPersonY(who,0);
		Abort(Math.pow((GetPersonY(who) - g_temp_y),2));
	}
}

function RandomWalk(who)
{
	var directions = [COMMAND_MOVE_NORTH,COMMAND_MOVE_SOUTH,COMMAND_MOVE_EAST,COMMAND_MOVE_WEST,COMMAND_WAIT];
	var random = Math.random() * directions.length-1;
	Walk(who,directions[random]);
}

function WalkPath(who,path_string)
{
	for (var i = 0; i < path_string.length; ++i)
	{
		switch(path_string.charAt(i))
		{
			case "n":
				Walk(who,COMMAND_MOVE_NORTH);
			break;
			case "s":
				Walk(who,COMMAND_MOVE_SOUTH);
			break;
			case "e":
				Walk(who,COMMAND_MOVE_EAST);
			break;
			case "w":
				Walk(who,COMMAND_MOVE_WEST);
			break;
			case "x":
				Walk(who,COMMAND_WAIT);
			break;
		}
	}
}